import {select, scaleOrdinal} from 'd3'

const xPosition = (d,i) => i * 140 + 100

const scaleColor = scaleOrdinal()
    .domain(['apple','lemon'])
	.range(['#c65035', '#c4d136']);

const scaleRad = scaleOrdinal()
    .domain(['apple','lemon'])
	.range(['45', '30']);

export const fruit = (selection, props) => {
    const {fruits, height} = props
    
    const groups = selection.selectAll('g').data(fruits,
                                                d => d.id);

  	const groupsEnter = groups.enter().append('g');
  
    groups.exit().select('circle')
      .transition()
    	.duration(1200)
      .attr('r', 0)
      .remove();
		
   groups.exit().select('text')
      .transition()
      .remove();
  
    	groupsEnter.append('circle')
  			.attr('r', 0)
        .attr('transform', (d,i) => 
              `translate(${i * 140 + 100}, ${height/2})`)
  			.merge(groups.select('circle'))
          .transition()
          .duration(1250)
          .attr('transform', (d,i) => 
                `translate(${i * 140 + 100}, ${height/2})`)
          .attr('r', d => scaleRad(d.type))
					.attr('fill', d => scaleColor(d.type));
  
  //I am not satified with all the duplicated logic below
  //I think there must be a way to make the labes directly inheret their locations from the circles
  
		groupsEnter.append('text')
  		.text(d => d.type)
  		.attr('transform', (d,i) => 
              `translate(${i * 140 + 100}, ${height/2})`)
  		.attr('y', 70)
  		.merge(groups.select('text'))
  		.transition()
  		.duration(1200)
			.text(d => d.type)
  		.attr('transform', (d,i) => 
              `translate(${i * 140 + 100}, ${height/2})`)
		
  	


};